SystemOrganization addCategory: #PluggableTextMorphWithLimits!

PluggableTextMorph subclass: #PluggableTextMorphWithLimits
	instanceVariableNames: 'warningLimit alertLimit'
	classVariableNames: 'DefaultWarningLimit'
	poolDictionaries: ''
	category: 'PluggableTextMorphWithLimits'!

!PluggableTextMorphWithLimits commentStamp: '<historical>' prior: 0!
I have a warningLimit ( 350 by default ) and an alertLimit ( 2* warningLimit by default ), and the number of characters of the text displayed is counted ( without space, tabs, cr etc).

If my text size is below the warning limit, the background is white ( or the default color ), if it is between warningLimit and alertLimit, the background turns more and more yellow, and if it's above the alertLimit, the background turns orange :)

Test it with: 

self example!

!PluggableTextMorphWithLimits class methodsFor: 'accessing' stamp: ''!
defaultWarningLimit

	^ DefaultWarningLimit ifNil: [ DefaultWarningLimit := 350 ]! !

!PluggableTextMorphWithLimits class methodsFor: 'accessing' stamp: ''!
defaultWarningLimit: anInteger
	" self defaultWarningLimit:nil "

	DefaultWarningLimit := anInteger! !

!PluggableTextMorphWithLimits class methodsFor: 'example' stamp: ''!
example
	" self example "

	| window textMorph |
	textMorph := self 
					on: self
					text: #getText
					accept: nil.
	window := StandardWindow new.
	window addMorph: textMorph frame: (0@0 corner: 1@1).
	window openInWorld.
	window title: 'PluggableTextMorphWithLimits example'! !

!PluggableTextMorphWithLimits class methodsFor: 'example' stamp: ''!
getText

	^ '
" an example to show that comments are not counted " 

asdasf
a
s

d

f

as d            kfj.
ha,sdkjhfaksdjhfakjsdhfakjsh.
df.kajhsdf.kajhsdf.kjahsd.fkj.
ahs.dkja.sdkfjha.sdkfjha.skdjfh.kasjdhf.kasjd


hf.aksjdhfakjsdhfwuelriuweliuqywerliquyerliqwuyerlqiwuyerliq
								wuyerliqwuyerlqiuweyrlqiwueyrlqwieuyrlqwiueyrlqwieuyrlqiweuyrlqwiuerylqiwueyrlqiwueyrlqiwueyrlqwiuerylqiwueyrlqiweuyrlqwieuyrlqwiueyrlqweiuyrlqwieuryqlwiehfgh
								
								
							
						((ENTER RANDOM CHARACTERS NOW))'! !

!PluggableTextMorphWithLimits class methodsFor: 'text' stamp: ''!
ignoredCharacters

	^ { Character space. Character tab. Character cr. $.. $;. $:. $'. $(. $) }! !

!PluggableTextMorphWithLimits class methodsFor: 'accessing' stamp: ''!
resetDefaultWarningLimit
	" self resetDefaultWarningLimit "

	self defaultWarningLimit: nil! !

!PluggableTextMorphWithLimits class methodsFor: 'text' stamp: ''!
textSizeOf: aText

	| result count ignoredCharacters |
	result := 0.
	count := true.
	ignoredCharacters := self ignoredCharacters.
	aText do: [:char |
		(char = $")
			ifTrue: [ count := count not ]
			ifFalse: [
				((ignoredCharacters includes: char) not and: [ count ])
					ifTrue: [ result := result + 1 ]]].
	^ result.! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: ''!
alertLimit

		^ alertLimit ifNil: [ alertLimit := 2 * (self warningLimit) ]! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: ''!
alertLimit: anObject
	
		alertLimit := anObject! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 3/20/2012 17:41'!
backgroundColorFor: rect
	"Return the current fillStyle of the receiver."
	
	| basicColor |
	basicColor := self basicColor.
	
	self warningLimit negative ifTrue: [ ^ basicColor ].
	
	textMorph ifNotNil: [ | size |
		size := self textSize.
		( size >= self warningLimit )
			ifTrue: [ | returnedColor overshoot transitionSpan transitionColor |
				transitionSpan := self warningLimit.
				transitionColor := Color yellow mixed: 0.6 with: self basicColor.
				( size >= self alertLimit )
					ifFalse: [ overshoot := size - self warningLimit ]
					ifTrue: [
						transitionSpan := self alertLimit - self warningLimit.
						basicColor := transitionColor mixed: 0.5 with: self basicColor.
						transitionColor := (Color orange mixed: 0.5 with: Color red) mixed: 0.5 with: self basicColor.
						overshoot := size - self alertLimit ].
				^ CompositeFillStyle fillStyles: {
					(GradientFillStyle 
						ramp: {0->transitionColor. 1 -> basicColor })
						origin: (rect width/2) @ rect bottom;
						direction: 0@((12+(2*rect height*overshoot / transitionSpan)) negated);
						normal: 0@1;
						radial: false;
						yourself.
					(GradientFillStyle 
						ramp: {0 -> Color white. 0.3->(Color white alpha: 0.01) })
						origin: rect left @ (rect height/2);
						direction: (rect width)@0;
						normal: 1@0;
						radial: false;
						yourself }
"				^ transitionColor mixed: overshoot / transitionSpan with: basicColor" ] ].
	
	^ basicColor
! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: ''!
basicColor

	^ extension
		ifNil: [ color]
		ifNotNil: [ extension fillStyle ifNil: [ color ]].! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 3/20/2012 16:46'!
basicWidth

	^ StandardFonts defaultFont widthOf: $2! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 3/20/2012 17:30'!
buildRectFrom: rect

	| top bottom right left |
	top := (rect bottom - StandardFonts defaultFont height - 4).
	bottom := rect bottom.
	right := rect right.
	left := right - ((self textSize printString size+1)*(self basicWidth)).
	self vIsScrollbarShowing 
		ifTrue: [ 
			right := right - scrollBar width.
			left := left - scrollBar width ].
	
	^ (left-5@top corner: right-5@bottom)! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 3/20/2012 17:38'!
drawOn: aCanvas

	| rect stringColor size top bottom newRect |

	super drawOn: aCanvas.
	
	size := self textSize.
	rect := self buildRectFrom: self bounds.
	top := bounds top + self borderWidth.
	bottom := bounds bottom - self borderWidth.
	stringColor := self stringColor.
	newRect := (rect left-self basicWidth-10)@top corner: (rect right)@bottom.
	aCanvas
		fillRectangle: newRect
		fillStyle: (self backgroundColorFor: newRect ).
	self wantsFrameAdornments ifTrue: [
		self theme drawTextAdornmentsFor: self on: aCanvas].

	(self warningLimit negative or: [ self warningLimit isZero ])
		ifFalse: [ 
			aCanvas 
				drawString: size printString 
				in: rect
				font: TextStyle defaultFont 
				color: stringColor ].! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 3/20/2012 16:04'!
fillStyle2
	"Return the current fillStyle of the receiver."
	
	| basicColor |
	basicColor := self basicColor.
	
	self warningLimit negative ifTrue: [ ^ basicColor ].
	
	textMorph ifNotNil: [ | size |
		size := self textSize.
		( size >= self warningLimit )
			ifTrue: [ | returnedColor overshoot transitionSpan transitionColor |
				transitionSpan := self warningLimit.
				transitionColor := Color yellow mixed: 0.6 with: self basicColor.
				( size >= self alertLimit )
					ifFalse: [ overshoot := size - self warningLimit ]
					ifTrue: [
						transitionSpan := self alertLimit - self warningLimit.
						basicColor := transitionColor mixed: 0.5 with: self basicColor.
						transitionColor := Color red mixed: 0.5 with: self basicColor.
						overshoot := size - self alertLimit ].
				^ (GradientFillStyle 
						ramp: {0->transitionColor. 1 -> basicColor })
						origin: (self width / 2) @ 0;
						direction: 0@(self height+(3*self height*overshoot / transitionSpan));
						normal: 0@800;
						radial: false;
						yourself
"				^ transitionColor mixed: overshoot / transitionSpan with: basicColor" ] ].
	
	^ basicColor
! !

!PluggableTextMorphWithLimits methodsFor: 'private' stamp: ''!
stringColor
	
	| size |
	size := self textSize.
	self warningLimit negative ifTrue: [ ^ Color black ].
	^ size >= self warningLimit
			ifTrue: [
				size >= self alertLimit
					ifTrue: [ Color red ]
					ifFalse: [ Color orange ]]
			ifFalse: [ Color black ].! !

!PluggableTextMorphWithLimits methodsFor: 'private' stamp: ''!
textSize

	^ self class textSizeOf: self text! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: ''!
warningLimit

		^ warningLimit ifNil: [ warningLimit := self class defaultWarningLimit ]! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: ''!
warningLimit: anObject
	
		warningLimit := anObject! !
